<?php

namespace FiloBlu\Storelocator\Model\Plugin\Rma;

class Config
{
    /**
     * @var \FiloBlu\Storelocator\Helper\Data
     */
    protected $helper;
    /**
     * @var \Magento\Framework\App\RequestInterface
     */
    protected $request;
    /**
     * @var \Magento\Rma\Model\ResourceModel\Rma\CollectionFactory
     */
    protected $rmaFactory;

    public function __construct(
        \FiloBlu\Storelocator\Helper\Data $helper,
        \Magento\Framework\App\RequestInterface $request,
        \Magento\Rma\Model\ResourceModel\Rma\CollectionFactory $rmaFactory
    )
    {
        $this->helper = $helper;
        $this->request = $request;
        $this->rmaFactory = $rmaFactory;
    }

    public function afterGetCopyTo(\Magento\Rma\Model\Config $subject, $result) {

        $orderId = $this->request->getParam('order_id');

        if (!$orderId) {
            return $result;
        }

        /** @var \Magento\Rma\Model\Rma $rma */
        $rma = $this->getRmaCollection($orderId);

        if ($rma->getStatus() !== 'pending') {
            return $result;
        }

        if ($this->helper->getReturnToStoreEnabled() && $rma->getReturnToStoreId()) {
            return null;
        }

        return $result;
    }

    public function getRmaCollection($orderId)
    {
        return $this->rmaFactory->create()->addFieldToSelect(
            '*'
        )->addFieldToFilter(
            'order_id',
            $orderId
        )->getLastItem();
    }
}